﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace QuakeViewer
{
    public partial class Form2 : Form
    {
        List<QuakeData> quakeList = null;
        public List<QuakeData> foundList = null;

        public Form2(List<QuakeData> quakeList)
        {
            InitializeComponent();
            this.quakeList = quakeList;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            DateTime timeMin = QuakeData.GetValue<DateTime>(dateTimePicker1.Text, DateTime.TryParse).GetValueOrDefault();
            DateTime timeMax = QuakeData.GetValue<DateTime>(dateTimePicker2.Text, DateTime.TryParse).GetValueOrDefault();
            double latMin = QuakeData.GetValue<Double>(textBox1.Text, Double.TryParse).GetValueOrDefault();
            double latMax = QuakeData.GetValue<Double>(textBox2.Text, Double.TryParse).GetValueOrDefault();
            double lonMin = QuakeData.GetValue<Double>(textBox3.Text, Double.TryParse).GetValueOrDefault();
            double lonMax = QuakeData.GetValue<Double>(textBox4.Text, Double.TryParse).GetValueOrDefault();
            double depthMin = QuakeData.GetValue<Double>(textBox5.Text, Double.TryParse).GetValueOrDefault();
            double depthMax = QuakeData.GetValue<Double>(textBox6.Text, Double.TryParse).GetValueOrDefault();
            double magMin = QuakeData.GetValue<Double>(textBox7.Text, Double.TryParse).GetValueOrDefault();
            double magMax = QuakeData.GetValue<Double>(textBox8.Text, Double.TryParse).GetValueOrDefault();

            System.Diagnostics.Trace.WriteLine("Found:");
            foundList = quakeList.FindAll(q => (q.Time > timeMin && q.Time < timeMax) ||
                                        (q.Latitude > latMin && q.Latitude < latMax) ||
                                        (q.Longitude > lonMin && q.Longitude < lonMax) ||
                                        (q.Depth > depthMin && q.Depth < depthMax) ||
                                        (q.Magnitude > magMin && q.Magnitude < magMax));
            foundList.ForEach(q => System.Diagnostics.Trace.WriteLine("Debug: filename=" + q));
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
