﻿using System;
using System.Collections.Generic;
using System.IO;

namespace QuakeViewer
{
    public class QuakeImporter
    {
        public static string FirstLine
        {
            get;
            set;
        }

        // Load CSV
        public static List<QuakeData> LoadCSV(string filename)
        {
            List<QuakeData> quakeList = new List<QuakeData>();

            if (File.Exists(filename))
            {
                //FileStream fs = new FileStream(filename, FileMode.Open, FileAccess.Read);

                // 한글처리시 필요함
                using (StreamReader sr = new StreamReader(filename, System.Text.Encoding.Default))
                {
                    string line = "";
                    char[] delimiter = { ',' }; // CSV
                    while ((line = sr.ReadLine()) != null)
                    {
                        System.Diagnostics.Trace.WriteLine(line);
                        if (String.Compare(line, 0, "time", 0, 4) == 0)
                        {
                            Console.WriteLine("첫번째 라인");
                            FirstLine = line;
                            continue;
                        }
                        else
                        {
                            // csv file format parse
                            string[] items = line.Split(delimiter);
                            /*foreach (string s in items)
                            {
                                System.Diagnostics.Trace.WriteLine(s);
                            }*/

                            // add QuakeData into List
                            QuakeData quake = QuakeData.Parse(items);
                            quake.ComputeColor();
                            //System.Diagnostics.Trace.WriteLine(quake);
                            quakeList.Add(quake);
                        }
                    }
                    sr.Close();
                    System.Diagnostics.Trace.WriteLine("Successfully Load " + filename);
                    return quakeList;
                }
            }
            System.Diagnostics.Trace.WriteLine("File " + filename + " not found");
            return null;
        }

        public static void WriteCSV(string path, List<QuakeData> quakeList)
        {
            // 한글처리시 필요함
            using (StreamWriter sw = new StreamWriter(path, false, System.Text.Encoding.Default))
            {
                sw.WriteLine(FirstLine);
                quakeList.ForEach(w => sw.WriteLine(w)); // QuakeData에 ToString() 사용
                sw.Close();
            }
        }
    }
}
