﻿using System;
using System.Collections;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace QuakeViewer
{
    class QuakeListViewItemComparer : IComparer
    {
        private int column = 0;

        public QuakeListViewItemComparer()
            : this(0)
        {
        }

        public QuakeListViewItemComparer(int column)
        {
            this.column = column;
        }

        public int Compare(object x, object y)
        {
            int result = 0;
            try
            {
                // Cast the objects to be compared to ListViewItem objects        
                ListViewItem listviewX = (ListViewItem)x;
                ListViewItem listviewY = (ListViewItem)y;

                if (column == 0)
                {
                    DateTime timeX, timeY;
                    bool value = DateTime.TryParse(((ListViewItem)x).SubItems[column].Text, out timeX);
                    value = DateTime.TryParse(((ListViewItem)y).SubItems[column].Text, out timeY);
                    result = timeX.CompareTo(timeY);
                }
                else if (column == 1 || column == 2 || column == 3 || column == 4)
                {
                    double numX, numY;
                    bool value = Double.TryParse(((ListViewItem)x).SubItems[column].Text, out numX);
                    value = Double.TryParse(((ListViewItem)y).SubItems[column].Text, out numY);
                    result = numX.CompareTo(numY);
                }
                else if (column == 5 || column == 6 || column == 7)
                {
                    result = String.Compare(listviewX.SubItems[column].Text, listviewY.SubItems[column].Text);
                }
            }
            catch
            {
                result = String.Compare(((ListViewItem)x).SubItems[column].Text, ((ListViewItem)y).SubItems[column].Text);
            }
            return result;
        }
    }
}
